﻿//160918 fujigaya2

//#include "Timertwo.h"
#include <avr/pgmspace.h>
//#include "TimerOne_x.h"
#include "VVVF_sound.h"

#include <Arduino.h>

#define  COUNT_CONSTANTSPEED  30

#include "D205_8000_WAV6L.h"//accel
#include "D205_8000_WAV6U.h"//accel
#include "D205_8000_WAV6UU.h"//accel
#include "D205_8000_WAV3.h"//idle
#include "DD51_start_WAV.h"//起動音
//#include "DD51_whistle_WAV.h"//ホイッスル
#include "horn0011.h"//ホイッスル

volatile unsigned int pwm_state1 = 0;
volatile unsigned int function_state1 = 0;
volatile int function_num = 0;
unsigned int interval_count = 3000;
unsigned int pwm_add = 0;
int pwm_mask = 0xff;
int pwm_shift = 8;
int current_duty_a = 0;
int SoundOn_count =0 ;


int gAccRatio = 20;
int gDecRatio = 20;
int gNotchSpdCount = 0;

uint8_t SoundSwitch = 0;
uint8_t SoundState = 1;
uint8_t SoundNotch = 0;
uint8_t SoundVolume = 10;
uint8_t gSoundLoopTiming = 8 ; // Variable set of Sound loop time by MECY 2017/05/14

int SoundWave_coeff = 1;


int SoundVolume_correct = 1;

float PrevSpeed = 0;

boolean vvvf_first_flag = true;//VVVF_Initを一回呼び出すためのFlag
boolean accel_flag = false;
boolean draft_flag = false;
uint8_t gSound_playnext = 0;
boolean accel_flag_prev = false;

//IMA WAV関連転記
//Sound played flag
//volatile uint8_t gSound_played = 0;
//uint8_t gSound_playnext = 0;
//volatile int gSound_Length = 0;
//uint8_t SoundState = 0;      // 0: idle  1:Sound再生待ち
//IMA-ADPCM add aya
//int gSound_offset = 0;      // aya add  RIFF フォーマットをそのまま使っているのでdata chunkまでoffsetを履かせる
//volatile uint16_t sample;   // volatile を使う意味があるかな？
//uint16_t ndata;             // 11/9 block数をカウント
//byte lastSample;            //
uint16_t nBlockAlign = 252;
IMADEC imad;
uint16_t nspeed;


//割り込みのひな形
void vvvf_int1();

void VVVF_Setup()
{

  //IMAADPCM初期設定
  uint8_t gSound_played = 0;
  //gSound_playnext = 1;
  //sample = 64;      // dataまでのオフセット
  //ndata = 0;        // IMA ADPCM の block を初期化
  nBlockAlign = (uint16_t)(readSoundRom(gSound_played, 33) << 8 | readSoundRom(gSound_played, 32)) - 4;//周波数によってブロックサイズが違う。
  //SoundState = 0;   // 再生終了
  //gSound_Length = (uint16_t)(readSoundRom(gSound_played, 57) << 8 | readSoundRom(gSound_played, 56)) - 13 * 20; // RIFF No56,No57
  nspeed = 500;//idleの時もAccelのときと時間を一緒にしておく。3500と3000
  //imad.val = (int16_t)(readSoundRom(gSound_played, 61) << 8 | readSoundRom(gSound_played, 60));   // Get 1st sample value of the block
  //imad.idx = readSoundRom(gSound_played, 62);

  //debug
  //pinMode(7, OUTPUT);
  
  //PWM出力ピン D9を出力にセット
  pinMode(VVVF_SOUND_PIN, OUTPUT);
  //Timer1使用
  //Timer1.initialize();
  //初期設定
  //Timer1.pwm(VVVF_SOUND_PIN,0,0);
  //Timer1.attachInterrupt(vvvf_int1,current_period1 / 2);//interruptの設定    

  //31KHzに設定（初期設定でPhaseCorrectPWMモードになっていると思う）
  //D9,D10  キャリア周期:31kHz(分周無し）
  TCCR1B &= B11111000;
  TCCR1B |= B00000001;

  //出力の設定
  if(VVVF_SOUND_PIN == 9)
  {
    TCCR1A |= _BV(COM1A1);
  }
  else //10
  {
    TCCR1A |= _BV(COM1B1);
  }
  
  //interrupt設定
  TIMSK1 = _BV(TOIE1);

}

void VVVF_SetCV(uint8_t iNo, uint8_t inData)
{
  switch (iNo)
  {
    case 3:

      if ( inData > 16)
      {
        gAccRatio = 255;
      }
      else
      {
        gAccRatio = inData * 16;
      }

      if ( gAccRatio <= 0)
      {
        gAccRatio = 1;
      }

      break;
    case 4:
      if ( inData > 16)
      {
        gDecRatio = 255;
      }
      else
      {
        gDecRatio = inData * 16;
      }

      if ( gDecRatio <= 0)
      {
        gDecRatio = 1;
      }
      break;
    case 47:
      SoundSwitch = inData;
      break;
    case 48:
      SoundState = inData;
      break;
    case 49:
      if(inData > 3)
      {
        inData = 3;
      }    
      SoundNotch = inData;
      break;
    case 50:
      if( inData > 8)
      {
        inData = 8;//0:min(no sound) ~ 8:max
      }    
      SoundVolume = inData;
      break;
    case 52:
      if ( inData > 40 )
      {
        gSoundLoopTiming = 40;
      }
      else
      {
        gSoundLoopTiming = inData;
      }
      if ( gSoundLoopTiming <= 0)
      {
        gSoundLoopTiming = 1;
      }
      break;
  }
}

//void VVVF_Cont(int inPWMFreq, uint8_t inF2Flag, uint8_t inF3Flag)
void VVVF_Cont(int inPWMFreq, uint8_t inF2Flag)
{
  uint16_t aPWMRef = 0;
  static uint8_t inF2Flag_static = 0x00; 
    
  uint8_t inF2Flag_ = inF2Flag & 0x01; //F3 OnOff
  uint8_t inF3Flag_ = (inF2Flag & 0x02 ) >> 1;//F4 加速音Lock

  //LPF routin
  float instruct_speed = (float)(inPWMFreq * 4);//change from 256 to 1023
  float speed_step = 0;

  if (inPWMFreq == 0)
  {
    accel_flag = false;
    PrevSpeed = 0;
  }
  else if ( PrevSpeed < instruct_speed )
  {
    //Acceleration
    accel_flag = true;
    speed_step = (abs(instruct_speed - PrevSpeed) / gAccRatio) + 1;
    PrevSpeed += speed_step ;
    if (PrevSpeed > instruct_speed)
    {
      PrevSpeed = instruct_speed;
    }
    //ノッチオフの音を止めるタイマ
    gNotchSpdCount = COUNT_CONSTANTSPEED;
  }
  else if ( PrevSpeed > instruct_speed )
  {
    //Deceleration
    accel_flag = false;
    speed_step = (abs(instruct_speed - PrevSpeed) / gDecRatio) + 1;
    PrevSpeed -= speed_step;
    if (PrevSpeed < instruct_speed)
    {
      PrevSpeed = instruct_speed;
    }
    gNotchSpdCount = 0;
  }
  else
  {
    //Constant speed
    if ( gNotchSpdCount > 0)
    {
      if (inF3Flag_ == 1)
      {
         if (nspeed < 2200)           //Not Shift down Sound in Notch Ctr Lock by  MECY 2017/10/07
         {
           gNotchSpdCount--;
         }
         else
         {
           // gNotchSpdCount--;        //Shift down Sound in Notch Ctr free by  MECY 2017/10/07
         }
      }
      else if(inF3Flag_ == 0)
      {
         gNotchSpdCount--;
      }
      accel_flag = true;
    }
    else
    {
      accel_flag = false;
    }
  }

  //Accel_flagがTrueの時は高回転、falseでアイドリングとするだけ
  if (accel_flag == true)
  {
    //accel
    //ディーセル回転数チックなもの
    if(nspeed < 1200)
    {
      gSound_playnext = 1;//accel
      nspeed += gSoundLoopTiming ;  // Variable set of Sound loop time by MECY 2017/05/14
    }
    else if(nspeed < 1800)
    {
      gSound_playnext = 2;//accel
      nspeed += gSoundLoopTiming ;  // Variable set of Sound loop time by MECY 2017/05/14
    }
    else if(nspeed < 2400)
    {
      gSound_playnext = 3;//accel
      nspeed += gSoundLoopTiming ;  // Variable set of Sound loop time by MECY 2017/05/14
    }
  }
  else
  {
    //idle
    //ディーセル回転数チックなもの
    if(nspeed > 1800)
    {
      gSound_playnext = 3;//accel
      nspeed -= gSoundLoopTiming * 2 ;  // Variable set of Sound loop time by MECY 2017/05/14
    }
    else if(nspeed > 1200)
    {
      gSound_playnext = 2;//accel
      nspeed -= gSoundLoopTiming * 2 ;  // Variable set of Sound loop time by MECY 2017/05/14
    }
    else if((nspeed > 500) && (PrevSpeed >= 4))   //無負荷走行の時はエンジン音はLow by MECY 2017/06/25
    {
      gSound_playnext = 1;//accel
      nspeed -= gSoundLoopTiming * 2 ;  // Variable set of Sound loop time by MECY 2017/05/14
    }
    else if( PrevSpeed < 4)  //停止している時だけidle音を鳴らす by MECY 2017/06/25
    {
      gSound_playnext = 0;//idle
      nspeed = 500;
    }
  }

  //nspeed →　interval_count変換 :ディーゼル周期変換
  uint8_t gSound_played1 = 0;
  uint16_t gSound_Length1 = (uint16_t)(readSoundRom(gSound_played1, 57) << 8 | readSoundRom(gSound_played1, 56)) - 13 * 20;
  interval_count = gSound_Length1 - nspeed / 4;
  //スタート音やホイッスルを鳴らしている最中は、SLと違って同期を取らずに鳴り終わったらすぐにエンジン音に行くための仕組み
  //function_num = 0が起動音やホイッスル終了のフラグなので、なっている間は高速にエンジン音側の周期を回す。
  if(function_num != 0)
  {
    interval_count = 100;
  }
  
  //ファンクション
  //変更されていたら鳴らす
  uint8_t temp_flag = inF2Flag_static ^ inF2Flag;
  switch(temp_flag)
  {
    case 0x01:
      //F03 On時に起動音にする
      if((inF2Flag & 0x01) == 1)
      {
        //F05 起動音
        function_num = 4;
        function_state1 = 0;
      }
      break;   
    case 0x02:
      //F04 加速音なので無視
      break;   
    case 0x04:
      //F05 起動音　単独
      function_num = 4;
      function_state1 = 0;
      break;   
    case 0x08:
      //F06　ホイッスル
      function_num = 5;
      function_state1 = 0;
      break;   
    default:
      break;   
  }
  //最後に値をStaticに入れておく
  inF2Flag_static = inF2Flag;

  //音量関連
  //最初の過渡対応(徐々に音量を大きくする）
  if(SoundVolume > (8 - pwm_shift))
  {
    pwm_shift --;
  }

  //サウンドオフ機構
  //SoundNotch == 2の時（手動操作時）にボリュームを操作
  if ((SoundNotch == 2)||(SoundNotch == 3))
  {
    if (inF2Flag_ == 1)
    {
      //ディーゼル音On
       SoundOn_count ++;                       //Sound On Deley  by  MECY 2017/10/07
      if((SoundOn_count > 80)&&(SoundNotch == 3))
      {
        draft_flag = true;
      }
      else if (SoundNotch == 2)
      {
        draft_flag = true;
      }
    }
    else
    {
      //ディーゼル音Off : pwm_shift == 8で音量0
      draft_flag = false;
      SoundOn_count = 0 ;
    }
  }
  else
  {
    //SoundNotchが2以外のときは何もしない
  }  

}

//void vvvf_int1()
ISR(TIMER1_OVF_vect)
{
  //波形生成用interrupt
  //ディーゼル音用　スピードで音色を変える
  static unsigned char flg = 0;  
  static unsigned char sound_num = 0;
  static unsigned int prev_value = 128;

  if(flg == 0x03)
  {
    if (VVVF_SOUND_PIN == 9)
    {
      OCR1A=prev_value>>pwm_shift;
    }
    else//(VVVF_SOUND_PIN == 10)
    {
      OCR1B=prev_value>>pwm_shift;
    }
    flg = 0x00;
    return;
  }
  else if(flg == 0x01)
  {
    flg++;
  }
  else
  {
    flg++;
    return;
  }
  
  unsigned int temp_value = 128;
 
  if((pwm_state1 > interval_count))
  {
    pwm_state1 = 0;
  }

  //ディーゼル音の管理
  if(pwm_state1 == 0)
  {
    //0の時に音色を進める
    //sound_num ++;
    sound_num = gSound_playnext; 
  }
  
  if(function_num == 0)
  {
    //ディーゼル音　
    temp_value = readWavData(sound_num & 0x03,pwm_state1);
  }
  else
  {
    //Function 4-6
    temp_value = readWavData(function_num,function_state1);
    function_state1 = 1;
  }

  //線形補間
  unsigned int temp_value2 = (temp_value + prev_value) >> 1;
  prev_value = temp_value;
  if (VVVF_SOUND_PIN == 9)
  {
    OCR1A=temp_value2>>pwm_shift;
  }
  else//(VVVF_SOUND_PIN == 10)
  {
    OCR1B=temp_value2>>pwm_shift;
  }
  //シュー音のOnOff
  if(draft_flag == true)
  {
    pwm_state1 ++;
  }
}

//元々のWAVで"pgm_read_byte_near(&WAV_DATA1 [temp_state])";に当たるところ
uint8_t readWavData(int gSound_played,unsigned int pwm_state1)
{
    static uint8_t hilow = LOW;   // add aya:最初は下位
    static uint16_t ndata = 0;
    static uint16_t sample = 64;
    static uint16_t gSound_Length =0;
    static uint8_t prev_value =128;
    //制御関連
    if (pwm_state1 == 0)
    {
      // 初期設定
      hilow = LOW;
      ndata = 0;
      sample = 64;
      imad.val = (int16_t)(readSoundRom(gSound_played, 61) << 8 | readSoundRom(gSound_played, 60));   // Get 1st sample value of the block
      imad.idx = readSoundRom(gSound_played, 62);
      gSound_Length = (uint16_t)(readSoundRom(gSound_played, 57) << 8 | readSoundRom(gSound_played, 56)) - 13 * 20; // RIFF No56,No57
      //nBlockAlign = (uint16_t)(readSoundRom(gSound_played, 33) << 8 | readSoundRom(gSound_played, 32)) - 4;//周波数によってブロックサイズが違う。      
      return 128;
    }
    else if  (sample >= gSound_Length - 50)     //差分は要検討
    {
      //音再生終了のため何もしない
      function_num = 0;//音終了のサイン
      return 128;
    }
    else if (ndata == nBlockAlign)    // 11/9 1 block 再生終わったら、val,idxを再セットする //16kHz?
    {
      ndata = 0;
      imad.val = (int16_t)(readSoundRom(gSound_played, sample + 1) << 8 | readSoundRom(gSound_played, sample)); // Get 1st sample value of the block
      imad.idx = readSoundRom(gSound_played, sample + 2);
      sample += 4;
      return prev_value;
    }
    
    //音再生
    uint8_t value = ima_decode(&imad, readSoundRom(gSound_played, sample), hilow);  // Sound extension by MECY 2017/08/02
    prev_value = value;
    if (hilow == HIGH)   // add aya : IMA ADPCM は1byteに4bit*2のデータがあるからね。
    {
      hilow = LOW;
      sample++;     // 再生アドレスをインクリメント
      ndata++;      // IMA ADPMC 1BLOCKカウントをインクリメント
    }
    else
    {
      hilow = HIGH;
    }
    return value;
}

//------------------------------------------------------------------------------
//  ROMに配置されている変数から値を取り出す処理
//------------------------------------------------------------------------------
byte readSoundRom(uint8_t inNo, uint16_t inOffset)
{
  switch (inNo) {
    case 0:
      return pgm_read_byte(&D205_8000_WAV3_data[inOffset]);
      break;
    case 1:
      return pgm_read_byte(&D205_8000_WAV6L_data[inOffset]);
      break;
    case 2:
      return pgm_read_byte(&D205_8000_WAV6U_data[inOffset]);
      break;
    case 3:
      return pgm_read_byte(&D205_8000_WAV6UU_data[inOffset]);
      break;
    case 4:
      return pgm_read_byte(&DD51_start_WAV_data[inOffset]);
      break;
    case 5:
      //return pgm_read_byte(&DD51_whistle_WAV_data[inOffset]);
      return pgm_read_byte(&horn0011_data[inOffset]);
      break;
    default:
      return 128;//無音
      break;
  }
}

/*----------------------------------------------------------------------------/
/* Sound Generator - A test of IMA-ADPCM decoder                              /
/*----------------------------------------------------------------------------/
/ This project, program codes and circuit diagrams, is opened under license
/ policy of following trems.
/
/  Copyright (C) 2013, ChaN, all right reserved.
/
/ * This project is a free software and there is NO WARRANTY.
/ * No restriction on use. You can use, modify and redistribute it for
/   personal, non-profit or commercial use UNDER YOUR RESPONSIBILITY.
/ * Redistributions of source code must retain the above copyright notice.
/
/----------------------------------------------------------------------------*/

//uint8_t ima_decode(    /* Returns the sample value (-32768 to 32767) */
uint16_t ima_decode(    /* Returns the sample value (-32768 to 32767) / Sound extension by MECY 2017/01/14 */
  IMADEC* ad,     /* Work area for the ADPCM stream */
  uint8_t dat,      /* ADPCM data, b3:sign (0:+, 1:-), b2-b0:magnify (0..7) */
  uint8_t hl      /* High or low data read */
)
{
  /*
    char buffer[20];
    sprintf( buffer,"%d,",sample);
    Serial.print(buffer);
  */
  static const uint16_t step[89] __attribute__((__progmem__)) = {
    //  static const uint16_t step[89] = {
    7, 8, 9, 10, 11, 12, 13, 14, 16, 17, 19, 21, 23, 25, 28, 31, 34, 37, 41, 45, 50, 55, 60, 66,
    73, 80, 88, 97, 107, 118, 130, 143, 157, 173, 190, 209, 230, 253, 279, 307, 337, 371, 408, 449,
    494, 544, 598, 658, 724, 796, 876, 963, 1060, 1166, 1282, 1411, 1552, 1707, 1878, 2066, 2272,
    2499, 2749, 3024, 3327, 3660, 4026, 4428, 4871, 5358, 5894, 6484, 7132, 7845, 8630, 9493,
    10442, 11487, 12635, 13899, 15289, 16818, 18500, 20350, 22385, 24623, 27086, 29794, 32767
  };

  int32_t dif;
  uint16_t stp;
  uint8_t idx;

  if (hl == HIGH)   // hl のフラグで、HIGHだったら、上位4bitを下位に移動
    dat = dat >> 4;
  dat = dat & 0x0f;
  /*
    sprintf( buffer,"%d,",dat);
    Serial.print(buffer);
  */
  /* Get current step size */
  idx = ad->idx;            // scale
  stp = pgm_read_word(&step[idx]);
  //  stp = step[idx];

  dif = stp >> 3;   // dif = stp / 8 と等価
  if (dat & 4) dif += stp;
  stp >>= 1;
  if (dat & 2) dif += stp;
  stp >>= 1;
  if (dat & 1) dif += stp;
  if (dat & 8) dif = 1 - dif;
  /* Add the difference to the previous sample */
  dif += ad->val;

  if (dif >  32767) dif =  32767;
  if (dif < -32768) dif = -32768;
  ad->val = (int16_t)dif;

  /* Update step size by magnify */
  dat = (dat & 7) - 4;

  if (dat > 3) {  /* Decrease step size by 1 if magnify is 0..3 */
    if (idx) idx--;
  } else {    /* Increase step size by 2..8 if magnify is 4..7 */
    idx += (dat + 1) << 1;
    if (idx > 88) idx = 88;
  }
  ad->idx = idx;

  //sprintf( buffer,"%#4x:%d",dif,dif);  要素が２つあると、ちゃんと変換できない
  //Serial.println(buffer);
  /*
    sprintf( buffer,"%d,",ad->val);
    Serial.print(buffer);
    sprintf( buffer,"%d,",ad->val/256+128);
    Serial.print(buffer);
    sprintf( buffer,"%d,",idx);
    Serial.println(buffer);
  */
  return ad->val / 256 + 128; /* PCM化した16bitのデータを8bitに間引いて、128のオフセットを履かせています*/
}
//------------------------------------------------------------------------------------

